using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http.Features;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using Microsoft.OpenApi.Models;

namespace TestServer
{
    /// <summary>
    /// 
    /// </summary>
    public class Startup
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Configuration

        /// <summary>
        /// 
        /// </summary>
        public IConfiguration Configuration { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Startup(configuration)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="configuration"></param>
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ÷ ϱ - ConfigureServices(serviceCollection)

        /// <summary>
        ///  ÷ ϱ
        /// </summary>
        /// <param name="serviceCollection"> ÷</param>
        public void ConfigureServices(IServiceCollection serviceCollection)
        {
            serviceCollection.AddControllers();

            serviceCollection.AddSwaggerGen
            (
                options =>
                {
                    options.SwaggerDoc("v1", new OpenApiInfo { Title = "TestServer", Version = "v1" });
                }
            );

            serviceCollection.Configure<FormOptions>
            (
                options =>
                {
                    options.MultipartBodyLengthLimit = 10737418240L; // 10GB
                }
            );
        }

        #endregion
        #region ϱ - Configure(applicationBuilder, webHostEnvironment)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="applicationBuilder">ø̼ </param>
        /// <param name="webHostEnvironment"> ȣƮ ȯ</param>
        public void Configure(IApplicationBuilder applicationBuilder, IWebHostEnvironment webHostEnvironment)
        {
            if(webHostEnvironment.IsDevelopment())
            {
                applicationBuilder.UseDeveloperExceptionPage();

                applicationBuilder.UseSwagger();

                applicationBuilder.UseSwaggerUI(c => c.SwaggerEndpoint("/swagger/v1/swagger.json", "TestServer v1"));
            }

            applicationBuilder.UseHttpsRedirection();

            applicationBuilder.UseRouting();

            applicationBuilder.UseAuthorization();

            applicationBuilder.UseEndpoints
            (
                endpointRouteBuilder =>
                {
                    endpointRouteBuilder.MapControllers();
                }
            );
        }

        #endregion
    }
}